## qtcreator 19.0.0~rc1

=== tests/auto/CMakeLists.txt ===
add_subdirectory(aggregation)
add_subdirectory(algorithm)
add_subdirectory(android)
add_subdirectory(changeset)
add_subdirectory(cplusplus)
add_subdirectory(debugger)
add_subdirectory(diff)
add_subdirectory(environment)
add_subdirectory(examples)
add_subdirectory(extensionsystem)
add_subdirectory(externaltool)
add_subdirectory(filesearch)
add_subdirectory(ios)
add_subdirectory(json)
add_subdirectory(languageserverprotocol)
add_subdirectory(pointeralgorithm)
add_subdirectory(profilewriter)
add_subdirectory(qml)
add_subdirectory(qmldebug)
add_subdirectory(sdktool)
add_subdirectory(solutions)
add_subdirectory(texteditor)
add_subdirectory(toolchaincache)
add_subdirectory(tracing)
add_subdirectory(treeviewfind)
add_subdirectory(updateinfo)
add_subdirectory(utils)
add_subdirectory(valgrind)

if(QTC_USES_INTERNAL_TASKTREE)
  add_subdirectory(qttasktree)
endif()
