=== src/libs/QtTaskTree/CMakeLists.txt ===
add_subdirectory(QtTaskTree)
