=== tests/manual/devcontainer/CMakeLists.txt ===
add_qtc_test(tst_devcontainer
  MANUALTEST
  DEPENDS DevContainer QtTaskTree
  SOURCES tst_devcontainer.cpp
)
