=== debian/changelog ===
qtcreator (19.0.0~rc1-1) experimental; urgency=medium

  * New upstream development release.

 -- Pino Toscano <pino@debian.org>  Thu, 26 Feb 2026 20:15:14 +0100
